
![GNOME Crosswords](images/hero.png)<br>
_A Crossword player and editor for GNOME._


**GNOME Crosswords** is a crossword player and editor.

Features:
*   Loads .ipuz and .puz files. Supports a significant chunk of the
    .ipuz spec for Crosswords
*   Supports standalone puzzle sets with multiple ways of playing them
*   External puzzle set downloaders can be used to download puzzles
*   Extensive styling support for crosswords. Square, black and white
    crosswords are traditional, but it can also take advantage of
    color and shapes
*   Reveal button to find mistakes and hint button to suggest answers
*   Puzzle checksums for puzzles that don't include an answer
*   Respects the Desktop-wide dark-mode preference.
*   Language-specific quirks
*   Supports barred, acrostic, and rebus puzzles

You can read about the latest changes in the [NEWS](NEWS.md) file.

![Example Puzzle](images/a-dogs-day.png)<br>
_Example crossword_

The game is available for [download](https://flathub.org/apps/details/org.gnome.Crosswords) in flathub.

### GNOME Crossword Editor

This program was originally intended to be a standalone game. However,
it grew a separate crossword editor after we realized that having a
standalone-tool to create crosswords was needed to create higher
quality crosswords. It is also a really interesting project to work
on.

The editor is still under development and is rudimentary in
nature. However, it can be used to create simple puzzles with grids
and clues. It has a pattern solver and grid autofill dialog for
filling in hard-to-finish corners, and will make suggestions of words
when creating the grid.

## Crosswords
This game won't be fun at all without good puzzles! If you are
interested in joining me in building a great set of crosswords for
people to play, [let me know](mailto:jrb@gnome.org)! I'd love to add a
bunch more puzzles to the game and showcase other people's works.

We support standalone puzzle sets, so it should be possible to bundle
up a bunch of puzzles together under a common theme and distribute
them as a standalone.

We export crosswords as [ipuz](http://ipuz.org) files loaded by
[libipuz](https://gitlab.gnome.org/jrb/libipuz). This is a great, free
file format.

_ipuz is a trademark of Puzzazz, Inc., used with permission_

## Building

This builds on most modern Linux distributions. It was developed on
Fedora and OpenSuse. You will need GTK 4.5 and libadwaita-1.2 in order
to build it. These will be as submodules if they aren't installed.

To build it, use standard meson tools:

```shell
$ meson setup _build
$ ninja -C _build
```

**Note:** The meson in Ubuntu 21.10 isn't recent enough to build this app. You can
install a local version of meson that's sufficiently new by running `pip3
install --user meson`.


### .puz files (Optional)

In order to load .puz files from disk, you need to install pypuz. It's
a python module that is used by the convertor script. The easiest way
to do this is to use pip:

```shell
$ pip install puzpy
```

## Running Crosswords

Running it out of the `builddir` is a little more involved as it
requires some environment variables set to work. To make this simple
and avoid a system installation, a `run` script is included.

Use it as follows:

```shell
$ cd _build/

$ # To run the game
$ ./run ./src/crosswords

$ # To run the crossword editor
$ ./run ./src/crossword-editor
```

## Test it!

Bugs should be reported to the our [bugtracking
system](https://gitlab.gnome.org/GNOME/gnome-crosswords/issues) on
GNOME gitlab.
